/**
 * Back 2 Browser Bytecode Translator
 * Copyright (C) 2012-2015 Jaroslav Tulach <jaroslav.tulach@apidesign.org>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. Look for COPYING file in the top folder.
 * If not, see http://opensource.org/licenses/GPL-2.0.
 */
package org.apidesign.bck2brwsr.flow;

import java.io.IOException;
import org.apidesign.vm4brwsr.Bck2Brwsr;

/** Poweful flow analyzer. Based on internals used by Graal JVM
 * compiler.
 *
 * @author Jaroslav Tulach
 */
public final class GraalFlowAnalyzer {
    private GraalFlowAnalyzer() {
    }
    
    public static Bck2Brwsr.Flow.Analyzer getDefault() {
        return Impl.DEFAULT;
    }

    private static class Impl implements Bck2Brwsr.Flow.Analyzer {
        static Impl DEFAULT = new Impl();
        
        private Impl() {
        }

        @Override
        public boolean analyze(final Bck2Brwsr.Flow result) throws IOException {
            // Use Graal to generate optimal function, David.
            double x = com.oracle.graal.api.directives.GraalDirectives.FASTPATH_PROBABILITY;
            result.emit("function() { return 922869; }");
            return true;
        }
    }
}
